package jp.gr.java_conf.wffm.gassan.data;

import java.util.*;
import java.io.*;

/**
 *  Copyright (c) 1999 щΎR,Yousuke Satou All Rights Reserved.
 *  1999/03/25
 *  SceneData:R̃f[^NX
 */
public class SceneData implements Serializable{

	//
	//  CX^Xϐ
	//
	//=========================================================================
	
	private String text = "";				//\镶
	private String CHFileName_Center = "";
	private String CHFileName_Right = "";	//\LN^[bf̃t@Cl[
	private String CHFileName_Left  = "";
	private String BGFileName = "";		//ɕ\wĩt@C
	private int BGEffectNumber = 0;			//wiƂ̃GtFNgԍ

	private String audioFileName = "";	//yt@C
	
	private boolean isJunction;				//falseʏ̃V[AtrueI
	
	private String[] junctionText = new String[JunctionMax];
	private String[] nextSceneFileName = new String[JunctionMax];	//̃V[̃t@CAString

	//
	//  NXϐ
	//
	//=========================================================================

	public  static final int JunctionMax = 3;
	//static final long serialVersionUID = -9033382142298844251L;
	static final long serialVersionUID = 6081558622310768798L;
/**
 * RXgN^[
 */
public SceneData() {
	super();
}
public String getAudioFileName(){
	return audioFileName;
}
public int getBGEffectNumber(){
	return BGEffectNumber;
}
public String getBGFileName(){
	return BGFileName;
}
public String getCHFileName_Center(){
	return CHFileName_Center;
}
public String getCHFileName_Left(){
	return CHFileName_Left;
}
public String getCHFileName_Right(){
	return CHFileName_Right;
}
public boolean getIsJunction() {
	return isJunction;
}
public String[] getJunctionText(){
	return junctionText;
}
public String getJunctionText(int i) {
	if(i < 0 || i >= JunctionMax)	return null;
	return junctionText[i];
}
public String[] getNextSceneFileName() {
	return nextSceneFileName;
}
public String getNextSceneFileName(int i) {
	if(i < 0 || i >= JunctionMax)	return null;
	return nextSceneFileName[i];
}
public String getText(){
	return text;
}
public void readObject(ObjectInputStream in) throws IOException, ClassNotFoundException {
	/*
	text = in.readUTF();
	
	CHFileName_Right = in.readUTF();
	CHFileName_Left  = in.readUTF();
	
	BGFileName       = in.readUTF();
	BGEffectNumber 	 = in.readInt();

	isJunction 		 = in.readBoolean();
	junctionText 	 = (String [])in.readObject();
	nextSceneFileName= (String [])in.readObject();
	*/
	/*
	text = in.readUTF();
	
	CHFileName_Right = in.readUTF();
	CHFileName_Left  = in.readUTF();
	
	BGFileName       = in.readUTF();
	BGEffectNumber 	 = in.readInt();

	audioFileName	 = in.readUTF();
	
	isJunction 		 = in.readBoolean();
	junctionText 	 = (String [])in.readObject();
	nextSceneFileName= (String [])in.readObject();
	*/
	in.defaultReadObject();
}
public void setAudioFileName(String s){
	this.audioFileName = s;
}
public void setBGEffectNumber(int i){
	BGEffectNumber = i;
}
public void setBGFileName(String s){
	BGFileName = s;
}
	public void setCHFileName_Center(String s){
	CHFileName_Center = s;
}
public void setCHFileName_Left(String s){
	CHFileName_Left = s;
}
public void setCHFileName_Right(String s){
	CHFileName_Right = s;
}
public void setIsJunction(boolean b) {
	isJunction = b;
}
public void setJunctionText(String[] str) {
	junctionText = str;
}
public void setJunctionText (String s,int i ) {
	if(i < 0 || i >= JunctionMax)	return;
	junctionText[i] = s;
	return;
}
public void setNextSceneFileName(String[] filename) {
	if(filename != null)
		nextSceneFileName = filename;
}
public void setNextSceneFileName (String s, int i ) {
	if(i < 0 || i >= JunctionMax)	return;
	nextSceneFileName[i] = s;
	return;
}
public void setText(String s){
	text = s;
}
public void writeObject(ObjectOutputStream out) throws IOException{
/*	
	out.writeUTF(text);
	
	out.writeUTF(CHFileName_Right);
	out.writeUTF(CHFileName_Left);
	
	out.writeUTF(BGFileName);
	out.writeInt(BGEffectNumber);
	
	out.writeBoolean(isJunction);
	out.writeObject(junctionText);
	out.writeObject(nextSceneFileName);
	*/
	/*
	out.writeUTF(text);
	
	out.writeUTF(CHFileName_Right);
	out.writeUTF(CHFileName_Left);
	
	out.writeUTF(BGFileName);
	out.writeInt(BGEffectNumber);

	out.writeUTF(audioFileName);
	
	out.writeBoolean(isJunction);
	out.writeObject(junctionText);
	out.writeObject(nextSceneFileName);
	*/
	out.defaultWriteObject();
}
}
