package org.wffm.gassan.view.effect;

/*
 * Patapata_Height_R.java - Short Description
 * Copyright (C) 1999-2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.Dimension;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.awt.Graphics;
import java.awt.Rectangle;

/**
  * C[WcɃp^p^NX(t)
  * ݎIɎDptH[}XeXgD
  * @version 0.9.3, 2001/01/06
  * @author Yosuke Sato
  */
public class Patapata_Height_R extends ExchangeEffect {
	//
	//  [Jϐ
	//
	//=========================================================================
	private int patapataWidth = 0;
	private int clock = 0;

	private static int patapata = 20; //p^p^̐
	private static int timer = 25;
/**
  * RXgN^
  */
public Patapata_Height_R() {
}
private void fillRect_Black(Graphics g,int lineNum1,int lineNum2) {
	g.setClip(new Rectangle(0,(lineNum1*patapataWidth),(int)getImageSize().getWidth(),patapataWidth)); 
	g.drawImage(getBeforeImage(),0,0,getComponent());
	g.setClip(new Rectangle(0,(lineNum2*patapataWidth),(int)getImageSize().getWidth(),patapataWidth));
	g.drawImage(getBeforeImage(),0,0,getComponent());
}
private void fillRect_Clear(Graphics g,int lineNum1,int lineNum2,int i) {
	int j = patapataWidth - (clock - i);
	if(j  < 0) j = 0;	
	g.setClip(new Rectangle(0,(lineNum1*patapataWidth ),(int)getImageSize().getWidth(),j));
	g.drawImage(getBeforeImage(),0,0,getComponent());
	g.setClip(new Rectangle(0,(lineNum2*patapataWidth ),(int)getImageSize().getWidth(),j));
	g.drawImage(getBeforeImage(),0,0,getComponent());
}
/**
  * ʏ
  */
public void init(){
	patapataWidth = ((int)getImageSize().getHeight() / 2)/patapata;
}
/**
  * ʏJn
  */
public void run(){
	//O:getImageSize(),getComponent(),getBeforeImage(),getAfterImage()nullłȂƁD
	if(getImageSize() != null && getComponent() != null && getBeforeImage() != null && getAfterImage() != null){
		Image buff = getComponent().createImage((int)getImageSize().getWidth(),(int)getImageSize().getHeight());
		Graphics g = getComponent().getGraphics();

		//㔼
		while(true){
			Graphics gc = buff.getGraphics();
			gc.drawImage(getAfterImage(),0,0,getComponent());
			for(int i = 1; i <= patapata;i++){
				int lineNum1 = (patapata - 1) - (i - 1);
				int lineNum2 = patapata+(i - 1);
				if(clock > i) 	fillRect_Clear(gc,lineNum1,lineNum2,i);
				else		fillRect_Black(gc,lineNum1,lineNum2);
			}
			g.drawImage(buff,0,0,getComponent());
			timer(timer);
			clock++;
			if(clock > 40) break;
		}
		clock = 0;
	}
	else{
		System.err.println("can not run Patapata_Height_R");
	}
}
}
