package org.wffm.gassan.view.filter;

/*
 * Filter.java - Short Description
 * Copyright (C) 2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.Image;
import java.awt.image.RGBImageFilter;
import java.util.Map;
import java.util.List;

import org.wffm.gassan.view.image.ImageCreater;

import org.wffm.gassan.view.image.ImageCreaterException;

/**
  * tB^[NX
  * @version 1.0.0, 2000/12/01
  * @author Yosuke Sato
  */
public abstract class Filter extends RGBImageFilter implements ImageCreater {
	//
	//  
	//
	//=========================================================================
	private Map param = null;
	private ImageCreater source = null;

	public static final String packageName = "org.wffm.gassan.view.filter.";
/**
 * RXgN^
 */
public Filter() {
	super();
}
/**
  * FilterpNX𐶐
  * @param	className	FilterpNX̖O
  * @return	ꂽFilter
  */
public static Filter create(String className) throws ImageCreaterException{
	Filter ret = null;
	
	try{
		ret = (Filter)Class.forName(className).newInstance();
	}
	catch(Exception e){
		ret = null;
	}
	
	//pbP[W⊮@\
	if(ret == null){
		try{
			ret = (Filter)Class.forName(packageName + className).newInstance();
		}
		catch(Exception e){
			System.err.println("Can not create Filter : " + className);
			throw new ImageCreaterException();
		}
	}
	
	return ret;
}
/**
  * p[^擾
  * @return	p[^
  */
public Map getParam(){
	return param;
}
/**
  * \[X擾
  * @return	\[X
  */
public ImageCreater getSource(){
	return source;
}
/**
  * p[^ݒ
  * @param	param	p[^
  */
public void setParam(Map param){
	this.param = param;
}
/**
  * \[Xݒ
  * @param	_source	\[X
  */
public void setSource(ImageCreater source){
	this.source = source;
}
}
