/* Public Domain Sources */

package org.wffm.gassan.view.loader.bmp;

import java.io.InputStream;
import java.io.DataInputStream;
import java.io.IOException;

/**
  * WordableDataInputStream
  * @version 1.0.0, 2000/12/01
  * @author D.Miki
  */
public class WordableDataInputStream extends DataInputStream {

  public WordableDataInputStream(InputStream is){super(is);}          

  public int readWORD() throws IOException {
	int ub = this.readUnsignedByte();
	return ub | (this.readUnsignedByte() << 8);
  }          

  public int readDWORD() throws IOException {
	int w = this.readWORD();
	return w | (this.readWORD() << 16);
  }          

}