package org.wffm.gsmlviewer.pane;

/*
 * TextPaneControler.java - Short Description
 * Copyright (C) 2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.Hashtable;

import org.wffm.gassan.model.GStage;

/**
  * TextPaneNX̃Rg[
  * @version 1.0.1, 2000/11/20
  * @author Yosuke Sato
  */
public class TextPaneController implements ActionListener {
	//
	//@֘A
	//
	//=========================================================================
	private TextPane _TextPane = null;
	private GStage _GStage = null;
/**
 * RXgN^
 * @param	_GStage	GStage
 * @param	_TextPane	TextPane
 */
public TextPaneController(GStage _GStage,TextPane _TextPane) {
	this._GStage = _GStage;
	this._TextPane = _TextPane;
}
public void actionPerformed(ActionEvent e) {
	if(_GStage != null && _TextPane != null){
		TextLabel label = (TextLabel)e.getSource();
		
		if(_TextPane.getState() == TextPane.LINE_WAIT && !_TextPane.getAutoRun() ){
			_TextPane.setMousePush(true);

			/*--- 
			L̃R[h̕IuWFNgwIɂ͔Thread.join()
			VXe֍ׂ邽ߒfO
			if(_TextPane.getThread() != null){
				try{
					_TextPane.getThread().join();
				}catch(InterruptedException ie){}
			}
			_GStage.reaction();
			--- */
		}
		else if(_TextPane.getState() == TextPane.PAGECHANGE_WAIT && !_TextPane.getAutoRun() ){
			_TextPane.setMousePush(true);
			
		}
		else if(_TextPane.getState() == TextPane.SELECTION_WAIT){
			if(label.getFocusPainted()){
				String alternative = label.getText();
				Hashtable operations = _TextPane.getOperations();
				
				String operation = (String)operations.get(alternative);
						
				_TextPane.setState(TextPane.NORMAL);

				if(_GStage.getDirector() != null){
					_GStage.getDirector().operation(operation);
				}
				_GStage.reaction();
			}
		}
	}
}
}
