package org.wffm.digicomi;

/*
 * D_PageEffect.java - Short Description
 * Copyright (C) 2000-2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.*;
import java.awt.image.*;

/**
  * y[W߂lɌʃGtFNgNX
  * @version 1.0.0, 2001/01/06
  * @author Yosuke Sato
  */
public class D_PageEffect extends org.wffm.gassan.view.effect.ExchangeEffect {
	//
	//  [Jϐ
	//
	//=========================================================================
	
	private Image previousLeftImage = null;
	private Image afterRightImage = null;
	private static int timer = 25;
	private static int rate = 10; //10
/**
  * ʏ
  */
public void init() throws org.wffm.gassan.view.effect.ExchangeEffectException {}
private void leftImageOperate(Graphics g,int x){
	g.setColor(Color.white);
	int y = (int)getImageSize().getHeight();
	g.fillRect(0,0,x,y);
	int x_image = ((int)getImageSize().getWidth() / 2) - x;
	g.drawImage(previousLeftImage,x,0,x_image,y,getComponent());
	
}
private void rightImageOperate(Graphics g,int x){
	int y = (int)getImageSize().getHeight();
	int x_start = (int)getImageSize().getWidth() / 2;
	int x_image = x - ((int)getImageSize().getWidth() / 2);
	g.drawImage(afterRightImage,x_start,0,x_image,y,getComponent());
	
}
/**
  * ʏJn
  */
public void run() {

	//O:getImageSize(),getComponent(),getBeforeImage(),getAfterImage()nullłȂƁD
	if(getImageSize() != null && getComponent() != null && getBeforeImage() != null && getAfterImage() != null){

		if(afterRightImage != null && previousLeftImage != null){

			Image buff = getComponent().createImage((int)getImageSize().getWidth(),(int)getImageSize().getHeight());
			Graphics g = getComponent().getGraphics();
			Graphics gc = buff.getGraphics();
			gc.setColor(Color.black);

			gc.drawImage(getBeforeImage(),0,0,getComponent());
			
			//O
			int x = 0;
			int x_add = ((int)getImageSize().getWidth() / 2) / rate;
			for(int i = 0;i <= rate;i++){
				leftImageOperate(gc,x);
				timer(timer);
				g.drawImage(buff,0,0,getComponent());
				x = x + x_add;
			}
			timer(timer*7);

			//㔼
			x = (int)getImageSize().getWidth() / 2;
			x_add = ((int)getImageSize().getWidth() / 2) / rate;
			for(int i = 0;i <= rate;i++){
				rightImageOperate(gc,x);
				timer(timer);
				g.drawImage(buff,0,0,getComponent());
				x = x + x_add;
			}
			timer(timer*7);
		}
	}

}
/**
  * ̉Ey[Wݒ
  * @param	afterRightImage	Ey[W
  */
public void setAfterRightImage(Image afterRightImage){
	this.afterRightImage = afterRightImage;
}
/**
  * O̍y[Wݒ
  * @param	previousLeftImage	Oy[W
  */
public void setPreviousLeftImage(Image previousLeftImage){
	this.previousLeftImage = previousLeftImage;
}
}
