package org.wffm.digicomi;

import java.awt.Dimension;
import java.awt.Point;
import java.awt.Color;

import javax.swing.JPanel;

import org.wffm.gsmlviewer.GSMLViewer;
import org.wffm.gsmlviewer.GFrame;
import org.wffm.gsmlviewer.GEMLUtility;
import org.wffm.gsmlviewer.pane.ImagePane;
import org.wffm.gsmlviewer.pane.TextPane;
import org.wffm.gsmlviewer.filter.ImagePaneFilter;
import org.wffm.gsmlviewer.filter.DialogTextFilter;

import org.wffm.gassan.model.scenario.GElement;
import org.wffm.gassan.model.scenario.GElementList;

import org.wffm.gsmlviewer.factory.ViewFactory;

/**
 * ^̋Lq}ĂB
 * 쐬 : (01/01/06 0:29:21)
 * @author: 
 */
public class DigicomiFactory extends ViewFactory {
	private final int tabSize = 20;			//^ũTCY
	private final int line = 2;				//s
	private final int emptyline = 1;		//󔒍s
	private D_GSMLViewer aD_GSMLViewer = null;
	private D_GFrame aD_GFrame = null;
	private D_ImagePane aD_ImagePane = null;
	private D_TextPane aD_TextPane = null;
	
	public static final int fontSize = 18;	//tHgTCY
public GFrame getGFrame(){
	if(aD_GFrame == null){
		aD_GFrame = new D_GFrame((D_GSMLViewer)getGSMLViewer());
	}
	return aD_GFrame;
}
public GSMLViewer getGSMLViewer(){
	if(aD_GSMLViewer == null){
		aD_GSMLViewer = new D_GSMLViewer();
	}
	return aD_GSMLViewer;
}
public ImagePane getImagePane(){
	if(aD_ImagePane == null){
		aD_ImagePane = new D_ImagePane();
	}
	return aD_ImagePane;
}
/**
  * eLXgGÃTCY擾
  * @return	eLXgGÃTCY
  */
private Dimension getTextAreaSize(Dimension viewSize){
	int width = (int)viewSize.getWidth() - (tabSize * 2);
	int height = ((fontSize+5) * line) + 5;	//5͍s
	return new Dimension(width,height);
}
/**
  * TextPane擾
  * @return	TextPane
  */
public TextPane getTextPane(){
	if(aD_TextPane == null){
		aD_TextPane = new D_TextPane();
	}
	return aD_TextPane;
}
/**
  * pl
  */
public void init_pane() {
	Dimension imageSize = getSize(getEnv());

	Point textPosition = new Point(tabSize,(int)imageSize.getHeight());
	Dimension textSize = getTextAreaSize(imageSize);

	getContentPane().setSize((int)imageSize.getWidth(),(int)(imageSize.getHeight() + textSize.getHeight() ));
	
	//TextPane&
	getTextPane().init(textSize,fontSize);
	
	//ImagePane&
	getImagePane().init(imageSize);

	//pl̑gݗĎ
	getContentPane().setBackground(Color.black);
	getContentPane().setLayout(null);
	getContentPane().add(getImagePane());
	getImagePane().setLayout(null);
	getContentPane().add(getTextPane());
	getTextPane().setBounds((int)textPosition.x,(int)textPosition.y,(int)textSize.getWidth(),(int)textSize.getHeight());
}
}
