package org.wffm.gassan.view.effect;

/*
 * Ellipse.java - Short Description
 * Copyright (C) 1999-2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.Dimension;
import java.awt.image.BufferedImage;
import java.awt.Graphics;
import java.awt.geom.Ellipse2D;

/**
  * ~`ɌGtFNgNX
  * @version 1.1.0, 2001/01/06
  * @author Yosuke Sato
  */
public class Ellipse extends ExchangeEffect {
	private static int per = 16;	//
	private static int timer = 25;
/**
  * RXgN^
  */
public Ellipse(){
}
private Ellipse2D.Double createEllipse2D(double x,double y,double r){
	//r͔a
	double _x = x - r;
	double _y = y - r;
	double w = r * 2;
	double h = r * 2;
	
	return new Ellipse2D.Double(_x,_y,w,h);
}
/**
  * ʏ
  */
public void init(){
}
/**
  * ʏJn
  */
public void run(){
	//O:getImageSize(),getComponent(),getBeforeImage(),getAfterImage()nullłȂƁD
	if(getImageSize() != null && getComponent() != null && getBeforeImage() != null && getAfterImage() != null){
		Graphics g = getComponent().getGraphics();
		int drawWidth = (int)getImageSize().getWidth();
		int drawHeight = (int)getImageSize().getHeight();
		
		int x = drawWidth / 2;
		int y = drawHeight / 2;
		int r;
		if( drawWidth > drawHeight ){
			r = (drawWidth / per) / 2;
		}
		else{
			r = (drawHeight / per) / 2;
		}
		g.drawImage(getBeforeImage(),0,0,getComponent());

		int _r = r;
		for(int i = 1;i <= per;i++){
			g.setClip(createEllipse2D(x,y,_r));
			g.drawImage(getAfterImage(),0,0,getComponent());
			timer(timer);
			_r = r*i;
		}
	}
	else{
		System.err.println("can not run : Patapata_Width");
	}
}
}
