package org.wffm.gassan.view.effect;

/*
 * Patapata_Height.java - Short Description
 * Copyright (C) 1999-2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.Dimension;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.awt.Graphics;
import java.awt.Rectangle;

/**
  * C[WcɃp^p^GtFNgNX
  * @version 1.1.0, 2001/01/06
  * @author Yosuke Sato
  */
public class Patapata_Height extends ExchangeEffect {
	//
	//  [Jϐ
	//
	//=========================================================================
 	private int patapataWidth = 0;
	private int clock = 0;
	
	private static int patapata = 20; //p^p^̐
	private static int timer = 25;
/**
  * RXgN^
  */
public Patapata_Height() {
}
private void fillRect(Graphics g,int lineNum1,int lineNum2,int i) {
	int j = clock - i;
	if(j > patapataWidth) j = patapataWidth;	
	g.setClip(new Rectangle(0,(patapataWidth+(lineNum1*patapataWidth)) - j ,(int)getImageSize().getWidth(),j));
	g.drawImage(getAfterImage(),0,0,getComponent());
	g.setClip(new Rectangle(0,(patapataWidth+(lineNum2*patapataWidth)) - j ,(int)getImageSize().getWidth(),j));
	g.drawImage(getAfterImage(),0,0,getComponent());
}
/**
  * ʏ
  */
public void init(){
	patapataWidth = ((int)getImageSize().getHeight() / 2)/patapata;
}
/**
  * ʏJn
  */
public void run(){
	//O:getImageSize(),getComponent(),getBeforeImage(),getAfterImage()nullłȂƁD
	if(getImageSize() != null && getComponent() != null && getBeforeImage() != null && getAfterImage() != null){
		Graphics g = getComponent().getGraphics();
		//O
		g.drawImage(getBeforeImage(),0,0,getComponent());
		while(true){
			for(int i = 1; i <= patapata;i++){
				int lineNum1 = i - 1;
				int lineNum2 = (patapata * 2) - i;
				if(clock > i)	fillRect(g,lineNum1,lineNum2,i);
			}
			timer(timer);
			clock++;
			if(clock > 40) break;
		}
		clock = 0;
	}
	else{
		System.err.println("can not run : Patapata_Height");
	}
}
}
