package org.wffm.gassan.view.loader;

/*
 * DefaultImageLoader.java - Short Description
 * Copyright (C) 2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.Image;
import java.net.URL;

import javax.swing.ImageIcon;

import org.wffm.gassan.view.image.ImageCreaterException;

/**
  * ftHgC[W[_NX
  * @version 1.0.0, 2000/12/01
  * @author Yosuke Sato
  */
public class DefaultImageLoader extends ImageLoader {
/**
 * RXgN^
 */
public DefaultImageLoader() {
	super();
}
/**
  * C[W擾
  * @return	C[W
  */
public Image getImage() throws ImageCreaterException{
	Image ret = null;
	
	try{
		if(getSrc() != null){
			ImageIcon imageIcon = new ImageIcon(getSrc());
			if(imageIcon.getIconWidth() == -1 || imageIcon.getIconHeight() == -1){
				throw new ImageCreaterException();
			}
			else{
				ret = imageIcon.getImage();
			}
		}
		else{
			throw new ImageCreaterException();
		}
	}catch(Exception e){
		throw new ImageCreaterException();
	}
	
	return ret;
}
}
