package org.wffm.gassan.view.loader;

/*
 * ImageLoader.java - Short Description
 * Copyright (C) 2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.net.URL;

import org.wffm.gassan.view.image.ImageCreater;
import org.wffm.gassan.view.image.ImageCreaterException;

/**
  * C[W[_NX
  * @version 1.0.0, 2000/12/01
  * @author Yosuke Sato
  */
public abstract class ImageLoader implements ImageCreater {
	private URL src = null;
	public static final String packageName = "org.wffm.gassan.view.loader.";
/**
 * RXgN^
 */
public ImageLoader() {
}
/**
  * ImageLoaderpNX𐶐
  * @param	className	ImageLoaderpNX̖O
  * @return	ꂽImageLoader
  */
public static ImageLoader create(String className) throws ImageCreaterException{
	ImageLoader ret = null;
	
	try{
		ret = (ImageLoader)Class.forName(className).newInstance();
	}
	catch(Exception e){
		ret = null;
	}
	
	//pbP[W⊮@\
	if(ret == null){
		try{
			ret = (ImageLoader)Class.forName(packageName + className).newInstance();
		}
		catch(Exception e){
			System.err.println("Can not create ImageLoader : " + className);
			throw new ImageCreaterException();
		}
	}
	
	return ret;
}
/**
  * \[X擾
  * @return	\[X
  */
public URL getSrc(){
	return src;
}
/**
  * \[Xݒ
  * @param	src	\[X
  */
public void setSrc(URL src){
	this.src = src;
}
}
