package org.wffm.gassan.view.plugin;

/*
 * GPlugin.java - Short Description
 * Copyright (C) 1999-2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.util.Map;
import java.awt.Image;

import javax.swing.JPanel;

import org.wffm.gassan.model.GStage;

/**
  * RvOC̊NX
  * @version 1.1.1, 2001/01/08
  * @author Yosuke Sato
  */
public abstract class GPlugin extends JPanel{
	
	//
	//  ֘A
	//
	//=========================================================================
	private GStage _stage = null;

	//
	//  
	//
	//=========================================================================
	private Map param = null;
	private Image backImage = null;
	
	public static final String packageName = "org.wffm.gassan.view.plugin.";
/**
  * GPluginpNX𐶐
  * @param	className	GPluginpNX̖O
  * @return	ꂽGPlugin
  */
public static GPlugin create(String className) {
	GPlugin ret = null;
	
	try{
		ret = (GPlugin)Class.forName(className).newInstance();
	}
	catch(Exception e){
		ret = null;
	}
	
	if(ret == null){
		//pbP[W⊮@\
		try{
			ret = (GPlugin)Class.forName(packageName + className).newInstance();
		}
		catch(Exception e){
			System.err.println("Can not create GPlugin : " + className);
			ret = null;
		}
	}
	
	return ret;
}
/**
  * wi擾
  * @return	wi
  */
public Image getBackImage(){
	return backImage;
}
/**
  * p[^擾
  * @return	p[^
  */
public Map getParam(){
	return param;
}
/**
  * 擾
  * @return	
  */
public GStage getStage(){
	return _stage;
}
/**
  * 
  */
public abstract void init() throws GPluginException;
/**
  * wiݒ
  * @param	backImage	wi
  */
public void setBackImage(Image backImage){
	this.backImage = backImage;
}
/**
  * p[^ݒ
  * @param	param	p[^
  */
public void setParam(Map param){
	this.param = param;
}
/**
  * ݒ
  * @param	stage	
  */
public void setStage(GStage _stage){
	this._stage = _stage;
}
	/**
	  * ^C}[
	  * @param	i	~b
	  */
	protected void timer(int i) {
		try{
			Thread.sleep(i);
		}catch(InterruptedException e){}
	}
}
